#include <string.h>
#include "spins.h"
#include "symmetry.h"
#include "config.h"
/*
        - liest Gitterdaten aus File -> MODELFILE=daten.def 
        - neu: datensaetze zeilen statt spaltenweise (12-1997)
    03/00 numpara dynamisch, ww.w added (twisted boundary conditions)
 */
/* ================== private-part =========================== */
#define MODELFILE "daten.def"

double pos[NN][3];                      /* site-position = (x,y,z)      */
double edg[3][3];                       /* edge vectors not_given=0 */
int  iw[Nw][2];                         /* array bonds                  */

int wt[Nw];                             /* (Bindungs-) Energien         */
int wj[Nw], wu[NN], we[NN];             /* nJJv faster if wj4=wj/4      */
int wf[NN];                             /* for an external field        */
struct tww ww;                          /* Parameter H                  */

int  nn,nw;                             /* number of spins and bonds NN,Nw */
int  nu,nd;                             /* number up-/down-spins        */
#if Nv
int iw2[Nv][2];                         /* intersite(-orbital) U,J  */
int wu2[Nv];                            /* coulomb  U(i,j)      */
int wj2[Nv];                            /* exchange J(i,j)      */
#endif 
char numpara=0;                         /* array for values     */
double para[MaxPara];                   /* values for wt,wj,etc. */


  int idx[NN];

  /*  i=site 0..NN, d=direction 0..2, s=steps ..,-1,0,1,.. rc=i+s*vec_d */
  /* besser site(i,dx,dy[,dz])  dy<0 geht nicht !!!!  */
  int site_move(int i,int dx,int dy,...){
    if(i<0 || i>=NN)return -1;
    if(dx==0 && dy==0) return 0;
    return(i);}

/*
 *  # +++model+++
 *  # NN Nw Nv
 *    2  1  0
 *  # s  X  Y  Z  e  U
 *    0  0  0  0  0  0
 *    1  1  0  0  0  0
 *  # n s1 s2  t  J  V
 *    0  0  1  2  1  0
 *  # ---model---
 */

  /* parser added for better inputfile error-detection  Mar2000 */
  int sdata(char *s){ /* check the string for usefull data (numbers) */
    int i,j,mode=0;
    for(i=j=0;i<1024 && s[i]!=0;i++){
      if(s[i]=='#' || s[i]=='%' || s[i]=='!' || s[i]==';') break; /* comment */
      if(s[i]==' ' || s[i]=='\t' || s[i]=='\r') { mode=0; } /* space */
      else { if(!mode){ mode=1;j++; } }
    }
    return j;	/* return number of values found */
  }

  int initvars(){	/* function definition */
    int i,j,k,l,p_max=0;FILE *f1;char s1[1024];
    for (i=0;i<3;i++) for (j=0;j<3;j++) edg[i][j]=0; /* default */
    nn=NN;nw=Nw;nu=NN/2;nd=NN/2+NN%2;i=j=k=0;	/* number of up- and down-spins */
    f1=fopen(MODELFILE,"rt");l=0;		/* l: linenumber */
    if(!f1)F1("could not open file %s",MODELFILE);
    if(vvv)printf(" read %s\n",MODELFILE);
    do {
      if (!fgets(s1,1023,f1)) F0("read");l++;
      if (s1[0]=='#' && l<8 && vvv) printf("%s",s1); /* output header */
      if (strncmp(s1,"#===edge===",11)==0) { /* edgevectors given? */
        i=sdata(s1+11); /* test for dimension = 1, 2 or 3 */
        if(i==1) sscanf(s1+11,"%lf",&edg[0][0]);
        if(i==4) sscanf(s1+11,"%lf%lf%lf%lf",
                   &edg[0][0],&edg[0][1],
                   &edg[1][0],&edg[1][1]);
        if(i==9) sscanf(s1+11,"%lf%lf%lf%lf%lf%lf%lf%lf%lf",
                   &edg[0][0],&edg[0][1],&edg[0][2],
                   &edg[1][0],&edg[1][1],&edg[1][2],
                   &edg[2][0],&edg[2][1],&edg[2][2]);
      }
    } while(!sdata(s1));
    if(sdata(s1)<2)F1("read line %d: numbers NN and Nw were expected",l);
    sscanf(s1,"%d%d%d",&nn,&nw,&k);if(NN!=nn || Nw<nw || 0!=k){ 
      printf("\nWARNING: NN Nw Nv not unique!"
             "\n daten.def: nn=%d nw=%d Nv=%d"
             "\n config.h:  NN=%d Nw=%d",nn,nw,k,NN,Nw);
      /* NN and Nw are used to define array boundaries, need a check */
      if (NN<nn || Nw<nw) F0("NN Nw to small, change config.h or daten.def");
    }
    for(i=0;i<nn;i++){
      do { if(!fgets(s1,1023,f1))F0("read");l++; } while(!sdata(s1));
      wf[i]=0; /* default field, if not set */
      if(sdata(s1)<5)F1("read line %d: 5-6 numbers expected",l);
      if(sdata(s1)>=6)
        sscanf(s1,"%d%lf%lf%lf%d%d%d",&idx[i],
          &pos[i][0],&pos[i][1],&pos[i][2],
          &we[i],&wu[i],&wf[i]);
      else
        sscanf(s1,"%d%lf%lf%lf%d%d",&idx[i],
          &pos[i][0],&pos[i][1],&pos[i][2],
      	  &we[i],&wu[i]);
#if CM(0,1,1)
      if(we[i]>p_max) p_max=we[i];
      if(wu[i]>p_max) p_max=wu[i];
#endif
#ifdef HFIELD
      if(wf[i]>p_max) p_max=wf[i];
#endif
    }
    for(i=nn;i<NN;i++){  /* fill unused elements with zeros */
      idx[i]=0; pos[i][0]=pos[i][1]=pos[i][2]=0; we[i]=wu[i]=wf[i]=0;
    }
    for(i=0;i<nw;i++){ 
      do { if(!fgets(s1,1023,f1))F0("read");l++; } while(!sdata(s1));
      if(sdata(s1)<5)F1("read line %d: 6 numbers expected",l);
      sscanf(s1,"%u%d%d%d%d%d",&j,&iw[i][0],&iw[i][1],&wt[i],&wj[i],&k);
#ifdef CONFIG_TBC
      sscanf(s1,"%*u%*d%*d%*d%*d%*d%d",&ww.w[i]);
      /* angle in units of pi */
      if(ww.w[i]>p_max) p_max=ww.w[i];
#else
      ww.w[i]=0;
#endif
      if(wj[i]>p_max) p_max=wj[i];
#if CM(0,1,1)
      if(wt[i]>p_max) p_max=wt[i];
#endif
      if(j>=nw)F2(" s=%d out of range 0..%d",j,nw-1);
      if(i!=j )E1(" idx!=%d",j);
      if(k!=0)E0("V!=0 not implemented yet"); }
    fclose(f1);
    /* if(vvv)printf("\n"); */
    if(p_max+1>=MaxPara)E0("MaxPara exceeded (look at spins.h?)");
    numpara=p_max+1;		/* number of different values */
    para[0]= 0.0;	/* immer 0 (allways 0) */
    para[1]= 1.0;	/* J1 */
    para[2]= 0.4;	/* J2 */
    para[3]= 0.0;	/* J3 */
    para[4]=-1.0;	/* t1 */
    para[5]= 0.1;	/* t2 */
    para[6]=-0.2;	/* t3 */
    para[7]= 0.0;	/* e */
    para[8]= 8.0;	/* U */
    return 0;
}


int outmodel(){		/* never used ??? example! */
  FILE *f1; int i;
  /* Ausgabe Modell in Maschinen-lesbarer Form (fuer allg. Model.H) */
  f1=fopen("daten.def","wt");		 /* DemoFile neu anlegen */
  if(!f1)F0("create daten.def");	if(vvv)printf(" write daten.def");
  fprintf(f1,"#+++model+++\n");
  fprintf(f1,"# NN=Number_of_sites Nw=Number_of_bonds Nv=Number_of_bonds(2)\n");
  fprintf(f1,"%2u %3u 0\n",nn,nw);
  fprintf(f1,"# s  X  Y  Z p_e p_U p_f (s=site  (X Y Z)=position  p=parameter-Nr)\n");
  for(i=0;i<NN;i++)
    fprintf(f1," %2u %2g %2g %2g %2d %2d %2d\n",
    i,pos[i][0],pos[i][1],pos[i][2],we[i],wu[i],wf[i]);
  fprintf(f1,"# Bond s1 s2 p_t p_J p_V p_w\n");
  for(i=0;i<nw;i++)
    fprintf(f1," %2u %2d %2d %2d %2d %2d %2d\n",
    i,iw[i][0],iw[i][1],wt[i],wj[i],0,ww.w[i]);
  fprintf(f1,"#---model---\n");
  fclose(f1);
  return(0); }

